/*
 * pwd.h definitions for use with LibC for NetWare
 * a collection that was assembled during the work with
 * several projects. See BSD license.
 *
 * Ulrich Neummann, december 2001
 *
 * POSIX Standard: 9.2.2 User Database Access <pwd.h>
 *
 */

#ifndef	_PWD_H_
#define	_PWD_H_

#include <stddef.h>
#include <time.h>
//#include <ldap.h>

/* The passwd structure.  */
typedef struct passwd
	{
	char	*pw_name;		/* username				*/
	char	*pw_passwd;		/* password				*/
	uid_t	pw_uid;			/* user ID				*/
	gid_t	pw_gid;			/* group ID				*/
	time_t	pw_change;		/* password change time */
	char 	*pw_class;		/* user access class	*/
	char	*pw_gecos;		/* real name			*/
	char	*pw_dir;		/* home directory		*/
	char	*pw_shell;		/* default shell		*/
	time_t	pw_expire;		/* account expiration	*/
	int		vm;				/* VM (internal use)	*/
//	LDAP	*ld;			/* LDAP (internal use)	*/
	} passwd;

#ifdef __cplusplus
extern "C"
{
#endif

/* Rewind the password-file stream.  */
void setpwent (void);

/* Close the password-file stream.  */
void endpwent (void);

/* Read an entry from the password-file stream, opening it if necessary.  */
//passwd* getpwent (void);

/* Search for an entry with a matching user ID.  */
passwd* getpwuid (int userid);

/* Search for an entry with a matching username.  */
//passwd* getpwnam (char *__name);

/* The following definitions have to be defined in unistd.h normally */
//int geteuid (void);

//int getuid (void);

/* NetWare additions */
/* VM dependent login via LDAP */
int posixlogin (char *__host, int __port, char *__name, char *__password, char *__context);

/* VM dependent logout via LDAP */
int posixlogout (void);

#ifdef __cplusplus
}
#endif

#endif /* pwd.h  */
